package pl.edu.amu.wmi.socialaggregator.activity

import android.annotation.SuppressLint
import android.os.Bundle
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.LinearLayoutManager
import com.google.android.material.snackbar.Snackbar
import com.jakewharton.rxbinding2.view.RxView
import kotlinx.android.synthetic.main.activity_new_post.*
import kotlinx.android.synthetic.main.content_new_post.*
import pl.edu.amu.wmi.socialaggregator.R
import pl.edu.amu.wmi.socialaggregator.utils.SocialPlatformsManager
import pl.edu.amu.wmi.socialaggregator.viewholders.SocialWithToggleRecycler

class NewPostActivity : AppCompatActivity() {

    @SuppressLint("CheckResult")
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_new_post)
        setSupportActionBar(toolbar)

        publishPost.setOnClickListener { view ->
            Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                .setAction("Action", null).show()
        }
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        val loggedInSocials = SocialPlatformsManager.getLoggedIn(this)

        val availablesRecycler = SocialWithToggleRecycler(loggedInSocials)
        availableSocials.apply {
            layoutManager = LinearLayoutManager(this@NewPostActivity)
            adapter = availablesRecycler
        }

        RxView.clicks(publishPost)
            .subscribe {
                availablesRecycler.chips.entries.forEach { (social, chip) ->
                    if (chip.isChecked) {
                        social.addPost(this, postText.text?.toString() ?: "test", emptyList())
                        Toast.makeText(this, "Posted to ${social.getName()}!", Toast.LENGTH_LONG)
                            .show()
                    }
                }
                finish()
            }
    }

}
