package pl.edu.amu.wmi.socialaggregator.viewholders

import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.recyclerview.widget.RecyclerView
import com.jakewharton.rxbinding2.view.RxView
import io.reactivex.disposables.Disposable
import pl.edu.amu.wmi.socialaggregator.R
import pl.edu.amu.wmi.socialaggregator.socialplatforms.SocialPlatform

class PostTextRecycler(
    val socials: List<Pair<SocialPlatform, Int>>) : RecyclerView.Adapter<PostTextRecycler.ViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val layout = LayoutInflater.from(parent.context)
            .inflate(R.layout.previous_posts, parent, false) as ConstraintLayout

        val socialName = layout.findViewById<TextView>(R.id.socialTextView)
        val postCount = layout.findViewById<TextView>(R.id.postCountTextView)

        return ViewHolder(layout, socialName, postCount)
    }

    override fun getItemCount(): Int {
        return socials.size
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val pair = socials[position]
        holder.socialName.text = pair.first.getName()
        val count = pair.second
        holder.postCount.text = count.toString() + if (count > 1) " posts" else " post"
    }

    class ViewHolder(
        root: ConstraintLayout,
        val socialName: TextView,
        val postCount: TextView
    ) : RecyclerView.ViewHolder(root)

}