package pl.edu.amu.wmi.socialaggregator.viewholders

import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.CheckBox
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.recyclerview.widget.RecyclerView
import com.google.android.material.chip.Chip
import pl.edu.amu.wmi.socialaggregator.R
import pl.edu.amu.wmi.socialaggregator.socialplatforms.SocialPlatform

class SocialWithToggleRecycler(
    private val availableSocials: List<SocialPlatform>
) : RecyclerView.Adapter<SocialWithToggleRecycler.ViewHolder>() {

    val chips = HashMap<SocialPlatform, CheckBox>()

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val layout = LayoutInflater.from(parent.context)
            .inflate(R.layout.social_platform_toggle, parent, false) as ConstraintLayout

        val textView = layout.findViewById<TextView>(R.id.socialPlatformName)
        val chip = layout.findViewById<CheckBox>(R.id.chip)

        return ViewHolder(layout, textView, chip)
    }

    override fun getItemCount(): Int {
        return availableSocials.size
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val social = availableSocials[position]
        holder.text.text = social.getName()

        chips[social] = holder.chip
    }

    class ViewHolder(
        root: ConstraintLayout,
        val text: TextView,
        val chip: CheckBox
    ) : RecyclerView.ViewHolder(root)

}